SystemOrganization addCategory: #'Magritte-XMLBinding'!
SystemOrganization addCategory: #'Magritte-XMLBinding-Test'!
SystemOrganization addCategory: #'Magritte-XMLBinding-Help'!

!MAElementDescription class methodsFor: '*magritte-xmlbinding' stamp: 'pmm 12/6/2006 00:18'!
descriptionXmlAttributeName
	^(MAStringDescription selector: #xmlAttributeName label: 'XML Attribute Name' priority: 1100)! !

!MAElementDescription methodsFor: '*magritte-xmlbinding' stamp: 'jvds 8/31/2010 14:02'!
beXmlAttribute
	"Store objects as an attribute of the parent node."
	"example: <parent attributeName='stringValue' />"
	self 
		beXmlExportable;
		xmlNode: MXSameNode;
		xmlAccess: MXAttributeAccess! !

!MAElementDescription methodsFor: '*magritte-xmlbinding' stamp: 'jvds 8/31/2010 13:51'!
beXmlChildAttribute
	"Store objects as an attribute of a child node."
	"example: <selector attributeName='stringValue' />"
	self 
		beXmlExportable;
		xmlNode: MXChildNode;
		xmlAccess: MXContentAccess! !

!MAElementDescription methodsFor: '*magritte-xmlbinding' stamp: 'jvds 8/31/2010 13:55'!
beXmlChildCData
	"Store objects as the CDATA content of a child node."
	"example: <selector>stringValue</selector>"
	self 
		beXmlExportable;
		xmlNode: MXChildNode;
		xmlAccess: MXContentCDataAccess! !

!MAElementDescription methodsFor: '*magritte-xmlbinding' stamp: 'jvds 8/31/2010 13:49'!
beXmlChildContent
	"Store objects as the content of a child node."
	"example: <selector>stringValue</selector>"
	self 
		beXmlExportable;
		xmlNode: MXChildNode;
		xmlAccess: MXContentAccess! !

!MAElementDescription methodsFor: '*magritte-xmlbinding' stamp: 'jvds 8/31/2010 15:58'!
beXmlChildElement
	"Store objects as the content of a child node."
	"example: <selector><child>....</child></selector>"
	self 
		beXmlExportable;
		xmlNode: MXChildNode;
		xmlAccess: MXElementAccess! !

!MAElementDescription methodsFor: '*magritte-xmlbinding' stamp: 'jvds 9/16/2010 16:09'!
defaultXmlAttributeName
	"Answer a default xml attribute name. Use the readSelector if present.
	Otherwise convert the label to a valid attribute name."
	
	^self defaultXmlElementName! !

!MAElementDescription methodsFor: '*magritte-xmlbinding' stamp: 'jvds 9/16/2010 16:09'!
xmlAttributeName
	^self
		propertyAt: #xmlAttributeName
		ifAbsent: [ self defaultXmlAttributeName ]! !

!MAElementDescription methodsFor: '*magritte-xmlbinding' stamp: 'pmm 12/6/2006 00:18'!
xmlAttributeName: aString
	self propertyAt: #xmlAttributeName put: aString! !

!MAElementDescription methodsFor: '*magritte-xmlbinding' stamp: 'NorbertHartl 3/16/2010 13:55'!
xmlAttributeSelector
	^self
		propertyAt: #xmlAttributeSelector
		ifAbsent: [ #yourself ]! !

!MAElementDescription methodsFor: '*magritte-xmlbinding' stamp: 'NorbertHartl 3/16/2010 13:59'!
xmlAttributeSelector: aSymbol
	self propertyAt: #xmlAttributeSelector put: aSymbol! !

MAVisitor subclass: #MXXmlBinding
	instanceVariableNames: 'object target access'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-XMLBinding'!

!MXXmlBinding methodsFor: 'accessing' stamp: 'NorbertHartl 2/21/2010 10:10'!
access
	^ access! !

!MXXmlBinding methodsFor: 'accessing' stamp: 'NorbertHartl 2/21/2010 10:10'!
access: aNodeAccess
	access := aNodeAccess! !

!MXXmlBinding methodsFor: 'accessing' stamp: 'NorbertHartl 2/21/2010 10:11'!
object
	^ object! !

!MXXmlBinding methodsFor: 'accessing' stamp: 'NorbertHartl 2/21/2010 10:11'!
object: anObject
	object := anObject! !

!MXXmlBinding methodsFor: 'accessing' stamp: 'NorbertHartl 2/21/2010 10:10'!
target
	^ target! !

!MXXmlBinding methodsFor: 'accessing' stamp: 'NorbertHartl 2/21/2010 10:09'!
target: aTargetNode
	target := aTargetNode! !

MXXmlBinding subclass: #MXXmlReader
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-XMLBinding'!

!MXXmlReader methodsFor: 'private' stamp: 'jvds 8/7/2010 12:00'!
descriptionFor: aContainerObject

	^aContainerObject description
! !

!MXXmlReader methodsFor: 'private' stamp: 'pmm 12/5/2006 22:57'!
error: aString
	MAReadError signal: aString! !

!MXXmlReader methodsFor: 'private' stamp: 'jvds 8/31/2010 15:04'!
newInstanceFor: aName with: aContainerDescription
	"Answer a new instance for the class described by aContainerDescription
	and with the xml name aName."

	| kind |
	
	kind := aContainerDescription kind == Object
		ifTrue: [ MXObject ]
		ifFalse: [ aContainerDescription kind ].
	
	kind withAllSubclassesDo: [ :each | each isAbstract ifFalse: [
		((self descriptionFor: each) xmlElementName = aName)
			ifTrue: [ ^each new ] ] ].
		
	self error: 'unknown element name: ', aName		
! !

!MXXmlReader methodsFor: 'visiting' stamp: 'NorbertHartl 3/16/2010 14:58'!
read: aNode description: aDescription
	self target currentNode: aNode.
	self target description: aDescription.
	^ self target readNode isNil ifFalse: [
		self visit: aDescription.
		self object ]! !

!MXXmlReader methodsFor: 'private' stamp: 'jvds 8/8/2010 15:56'!
valueUsing: aDescription do: aBlock

	(self access readNode: self target readNode description: aDescription) 
		ifNotNilDo: aBlock! !

!MXXmlReader methodsFor: 'visiting' stamp: 'jvds 9/16/2010 08:58'!
visitContainer: aDescription

	self object: (self newInstanceFor: self target readNode name with: aDescription).
	((self descriptionFor: self object) children 
		select: [ :each | each isReadonly not ]) do: [ :each |
			self object
				write: (each fromXmlNode: self target readNode)
				using: each ]! !

!MXXmlReader methodsFor: 'visiting' stamp: 'jvds 8/8/2010 15:56'!
visitElementDescription: aDescription

	self valueUsing: aDescription do: [ :val | self object: (aDescription fromString: val)]
	! !

!MXXmlReader methodsFor: 'visiting' stamp: 'jvds 8/31/2010 21:44'!
visitSingleOptionDescription: aDescription
	"If the option value is a class than just output the class name instead of the label"
	
	aDescription reference kind = Class
		ifTrue: [
			self valueUsing: aDescription do: [ :val |
				self object: (Smalltalk at: val asSymbol) ]]
		ifFalse: [ 
			super visitSingleOptionDescription: aDescription ]! !

!MXXmlReader methodsFor: 'visiting' stamp: 'jvds 9/16/2010 08:59'!
visitToManyRelationDescription: aDescription

	self object: (Array streamContents: [ :stream |
		self target readNode elementsDo: [ :each |
			(each name = aDescription reference xmlElementName)
				ifTrue:  [ stream nextPut: (aDescription reference fromXmlNode: each)]]])
		
	! !

!MXXmlReader methodsFor: 'visiting' stamp: 'jvds 8/31/2010 17:20'!
visitToOneRelationDescription: aDescription
	self object: (aDescription reference 
		fromXmlNode: (self access 
			readNode: self target readNode 
			description: aDescription reference))! !

MXXmlBinding subclass: #MXXmlWriter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-XMLBinding'!

!MXXmlWriter methodsFor: 'visiting-description' stamp: 'jvds 9/29/2010 20:28'!
visitContainer: aDescription
	"Write out all the elements of object that are xml exportable
	and are notNil."
	
	(aDescription children select:[:each| each isXmlExportable ]) do: [:each|
		(self object readUsing: each) ifNotNilDo: [:obj|
			| node |
			node := each toXmlNode: self object parent: self target writeNode.
			self access
				writeNode: node
				node: self target writeNode
				description: each ] ]! !

!MXXmlWriter methodsFor: 'visiting-description' stamp: 'NorbertHartl 3/16/2010 15:13'!
visitDateDescription: aDescription
	self access 
		write: (self object readUsing: aDescription) asUTC asString
		node: self target writeNode
		description: aDescription		! !

!MXXmlWriter methodsFor: 'visiting-description' stamp: 'jvds 8/8/2010 15:41'!
visitElementDescription: aDescription
	self 
		write: (aDescription toString: (self object readUsing: aDescription)) 
		using: aDescription! !

!MXXmlWriter methodsFor: 'visiting-description' stamp: 'jvds 8/8/2010 22:49'!
visitFileDescription: aDescription

	| fileModel |
	
	fileModel := self object readUsing: aDescription.
	fileModel notNil
		ifTrue: [
			self writeNode
				attributeAt: 'filename' put: fileModel filename;
				attributeAt: 'mimetype' put: fileModel mimetype.
			fileModel isText
				ifTrue: [ self writeNode addContent: fileModel contents asString ]
				ifFalse: [ self writeNode addContent: fileModel contents base64Encoded ]]! !

!MXXmlWriter methodsFor: 'visiting-description' stamp: 'jvds 8/8/2010 15:47'!
visitSingleOptionDescription: aDescription
	"If the option value is a class than just output the class name instead of the label"
	
	aDescription reference kind = Class
		ifTrue: [
			self 
				write: ((self object readUsing: aDescription) ifNotNil: [ :c | c name greaseString ])
				using: aDescription ]
		ifFalse: [ 
			super visitSingleOptionDescription: aDescription ]		! !

!MXXmlWriter methodsFor: 'visiting-description' stamp: 'jvds 8/31/2010 15:25'!
visitToManyRelationDescription: aDescription
	(self object readUsing: aDescription) do: [ :each |
		self write: each using: aDescription reference]
		
	! !

!MXXmlWriter methodsFor: 'visiting-description' stamp: 'jvds 9/16/2010 16:53'!
visitToOneRelationDescription: aDescription
	"What should we do with a nil reference?"
	self access 
		write: (object readUsing: aDescription)
		node: self target writeNode
		description: aDescription reference
		! !

!MXXmlWriter methodsFor: 'private' stamp: 'NorbertHartl 3/15/2010 19:37'!
write: anObject
	self write: anObject using: anObject description! !

!MXXmlWriter methodsFor: 'public' stamp: 'jvds 8/31/2010 18:25'!
write: anObject node: aParentNode description: aDescription
	self target 
		currentNode: aParentNode;
		description: aDescription.
	self 
		object: anObject;
		visit: aDescription.! !

!MXXmlWriter methodsFor: 'private' stamp: 'jvds 8/31/2010 18:28'!
write: aString using: aDescription
	self access
		write: aString
		node: self target writeNode
		description: aDescription
		! !

!MXXmlWriter methodsFor: 'accessing' stamp: 'NorbertHartl 3/16/2010 15:07'!
writeNode
	^ self target writeNode! !

CustomHelp subclass: #MXMagritteXMLBindingHelp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-XMLBinding-Help'!

MXMagritteXMLBindingHelp subclass: #MXMagritteXMLBindingAPIDocumentation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-XMLBinding-Help'!

!MXMagritteXMLBindingAPIDocumentation class methodsFor: 'accessing' stamp: 'jvds 9/23/2010 20:42'!
bookName
	^'API Documentation'! !

!MXMagritteXMLBindingAPIDocumentation class methodsFor: 'defaults' stamp: 'jvds 9/23/2010 20:42'!
builder
	^PackageAPIHelpBuilder! !

!MXMagritteXMLBindingAPIDocumentation class methodsFor: 'accessing' stamp: 'jvds 9/23/2010 20:43'!
packages

	^#( 'Magritte-XMLBinding' )! !

!MXMagritteXMLBindingHelp class methodsFor: 'accessing' stamp: 'jvds 9/23/2010 20:39'!
bookName

	^'Magritte-XMLBinding Help'! !

!MXMagritteXMLBindingHelp class methodsFor: 'pages' stamp: 'jvds 9/29/2010 20:26'!
introduction
	"This method was automatically generated. Edit it using:"
	"MXMagritteXMLBindingHelp edit: #introduction"
	^HelpTopic
		title: 'Introduction'
		contents: 
'With the XMLBinding extension to Magritte object can be serialized and deserialized to a custom XML format..
!!' readStream nextChunkText! !

!MXMagritteXMLBindingHelp class methodsFor: 'accessing' stamp: 'jvds 9/23/2010 20:39'!
key
	^'MXMagritteXMLBindingHelp'! !

!MXMagritteXMLBindingHelp class methodsFor: 'accessing' stamp: 'jvds 9/23/2010 20:39'!
pages
	^#(introduction)! !

!MAContainer class methodsFor: '*magritte-xmlbinding' stamp: 'NorbertHartl 2/21/2010 18:25'!
defaultXmlAccess
	^ MXElementAccess! !

!MAContainer class methodsFor: '*magritte-xmlbinding' stamp: 'NorbertHartl 2/21/2010 18:24'!
defaultXmlNode
	^ MXSeparateNode! !

!MADescription class methodsFor: '*magritte-xmlbinding' stamp: 'NorbertHartl 2/21/2010 18:25'!
defaultXmlAccess
	^ MXAttributeAccess ! !

!MADescription class methodsFor: '*magritte-xmlbinding' stamp: 'NorbertHartl 2/21/2010 18:23'!
defaultXmlNode
	^ MXSameNode! !

!MADescription class methodsFor: '*magritte-xmlbinding' stamp: 'NorbertHartl 02/22/2010 00:25'!
defaultXmlReader
	^ MXXmlReader ! !

!MADescription class methodsFor: '*magritte-xmlbinding' stamp: 'NorbertHartl 2/21/2010 15:08'!
defaultXmlWriter
	^MXXmlWriter ! !

!MADescription class methodsFor: '*magritte-xmlbinding' stamp: 'pmm 12/5/2006 18:42'!
descriptionXmlElementName
	^(MAStringDescription selector: #xmlElementName label: 'XML Element Name' priority: 1000)! !

!MADescription class methodsFor: '*magritte-xmlbinding' stamp: 'NorbertHartl 02/22/2010 00:26'!
descriptionXmlReader
	^ (MASingleOptionDescription selector: #xmlReader label: 'XML Reader' priority: 1300 default: self defaultXmlReader)
		reference: MAClassDescription new;
		options: (Array
			with: MXXmlReader);
		yourself ! !

!MADescription methodsFor: '*magritte-xmlbinding' stamp: 'NorbertHartl 2/19/2010 17:53'!
beXmlExportable
	self propertyAt: #xmlExportable put: true! !

!MADescription methodsFor: '*magritte-xmlbinding' stamp: 'jvds 9/16/2010 08:54'!
defaultXmlElementName
	"Answer a default xml element name. Use the readSelector if present.
	Otherwise convert the label to a valid element name."

	| name |
	
	(self accessor respondsTo: #readSelector)
		ifTrue: [ ^self accessor readSelector greaseString ].
		
	name := self label select: [ :char | char isAlphaNumeric ].
	name size > 0
		ifTrue: [ name at: 1 put: name first asLowercase ].
	^name! !

!MADescription methodsFor: '*magritte-xmlbinding' stamp: 'jvds 8/31/2010 11:59'!
fromXml: aString
	"Answer an object being parsed from <code>aString</code>."

	^ self fromXml: aString reader: self xmlReaderInstance! !

!MADescription methodsFor: '*magritte-xmlbinding' stamp: 'jvds 8/31/2010 10:30'!
fromXml: aString reader: aParser
	"Answer an object being parsed from <code>aNode</code> using <code>aParser</code>."

	| node |
	node :=  (XMLDOMParser parseDocumentFrom: aString readStream) root.
	^self fromXmlNode: node reader: aParser! !

!MADescription methodsFor: '*magritte-xmlbinding' stamp: 'jvds 8/31/2010 11:58'!
fromXmlNode: aNode 
	"Answer an object being parsed from <code>aNode</code>."

	^self fromXmlNode: aNode reader: self xmlReaderInstance! !

!MADescription methodsFor: '*magritte-xmlbinding' stamp: 'jvds 8/31/2010 10:28'!
fromXmlNode: aNode reader: aParser
	"Answer an object being parsed from <code>aNode</code> using <code>aParser</code>."

	^aParser read: aNode description: self! !

!MADescription methodsFor: '*magritte-xmlbinding' stamp: 'NorbertHartl 2/19/2010 17:53'!
isXmlExportable
	^ self propertyAt: #xmlExportable ifAbsent: [ false ]! !

!MADescription methodsFor: '*magritte-xmlbinding' stamp: 'jvds 8/31/2010 10:26'!
toXml: anObject
	"Answer a String created from anObject using the receiver as the description."
	
	| xml |
	xml := self toXmlNode: anObject.	
	^String streamContents: [ :stream | xml printXMLOn: (XMLWriter on: stream)]! !

!MADescription methodsFor: '*magritte-xmlbinding' stamp: 'jvds 8/31/2010 12:18'!
toXmlNode: anObject
	"Answer a XML Node created from anObject using the receiver as the description."

	^self toXmlNode: anObject parent: nil! !

!MADescription methodsFor: '*magritte-xmlbinding' stamp: 'jvds 8/31/2010 12:18'!
toXmlNode: anObject parent: aParentNode
	"Answer a XML Node created from anObject using the receiver as the description. If the receivers
	xmlNode is MXSameNode than anObject will be added to aParentNode. Otherwise aParentNode
	will be ignored."

	^self xmlWriterInstance
		write: anObject node: aParentNode description: self;
		writeNode.! !

!MADescription methodsFor: '*magritte-xmlbinding' stamp: 'NorbertHartl 2/21/2010 08:34'!
xmlAccess
	^ self propertyAt: #xmlAccess ifAbsent: [ self class defaultXmlAccess ]! !

!MADescription methodsFor: '*magritte-xmlbinding' stamp: 'NorbertHartl 2/21/2010 08:46'!
xmlAccess: aClass
	self propertyAt: #xmlAccess put: aClass! !

!MADescription methodsFor: '*magritte-xmlbinding' stamp: 'jvds 8/4/2010 22:25'!
xmlElementName
	^self
		propertyAt: #xmlElementName
		ifAbsent: [ self defaultXmlElementName ]! !

!MADescription methodsFor: '*magritte-xmlbinding' stamp: 'pmm 12/5/2006 20:16'!
xmlElementName: aString
	self propertyAt: #xmlElementName put: aString! !

!MADescription methodsFor: '*magritte-xmlbinding' stamp: 'NorbertHartl 2/21/2010 08:33'!
xmlNode
	^ self propertyAt: #xmlNode ifAbsent: [ self class defaultXmlNode ]! !

!MADescription methodsFor: '*magritte-xmlbinding' stamp: 'NorbertHartl 2/21/2010 08:33'!
xmlNode: aClass
	self propertyAt: #xmlNode put: aClass! !

!MADescription methodsFor: '*magritte-xmlbinding' stamp: 'jvds 8/31/2010 11:59'!
xmlReader
	^self propertyAt: #xmlReader ifAbsent: [ self class defaultXmlReader ]! !

!MADescription methodsFor: '*magritte-xmlbinding' stamp: 'jvds 8/7/2010 12:19'!
xmlReader: aReader
	self propertyAt: #xmlReader put: aReader! !

!MADescription methodsFor: '*magritte-xmlbinding' stamp: 'jvds 8/31/2010 12:02'!
xmlReaderInstance
	"Answer a XMLReader instance"

	^self xmlReader new
		target: self xmlNode new;
		access: self xmlAccess new;
		yourself! !

!MADescription methodsFor: '*magritte-xmlbinding' stamp: 'jvds 8/31/2010 12:07'!
xmlWriter
	
	^self propertyAt: #xmlWriter ifAbsent: [ self class defaultXmlWriter ]! !

!MADescription methodsFor: '*magritte-xmlbinding' stamp: 'NorbertHartl 2/21/2010 18:15'!
xmlWriter: aWriter
	self propertyAt: #xmlWriter put: aWriter! !

!MADescription methodsFor: '*magritte-xmlbinding' stamp: 'jvds 8/31/2010 12:03'!
xmlWriterInstance
	
	^self xmlWriter new
		target: self xmlNode new;
		access: self xmlAccess new;
		yourself! !

TestCase subclass: #MXXmlObjectTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-XMLBinding-Test'!

!MXXmlObjectTest methodsFor: 'fixtures' stamp: 'NorbertHartl 2/21/2010 08:04'!
simpleObject
	^ MXSimpleObject new
		title: 'A title';
		abstract: 'A longer text as abstract';
		token: 'article';
		index: 100000 atRandom;
		date: Date today! !

!MXXmlObjectTest methodsFor: 'testing' stamp: 'NorbertHartl 3/16/2010 14:10'!
testAttributeWrite
	| object xmlString |
	object := MXSimpleObject new
		title: 'A title'.
	xmlString := String streamContents: [:stream|
		object printXMLOn: stream].
	self assert: xmlString = '<simpleobject title="A title"/> '! !

!MXXmlObjectTest methodsFor: 'testing' stamp: 'NorbertHartl 3/16/2010 14:15'!
testChildNodeAttributeWrite
	| object xmlString |
	object := MXSimpleObject new
		token: 'a subelement attribute'.
	xmlString := String streamContents: [:stream|
		object printXMLOn: stream].
	self assert: xmlString = '<simpleobject><token type="a subelement attribute"/> </simpleobject>'! !

!MXXmlObjectTest methodsFor: 'testing' stamp: 'NorbertHartl 3/16/2010 14:12'!
testChildNodeContentWrite
	| object xmlString |
	object := MXSimpleObject new
		abstract: 'Some words as abstract'.
	xmlString := String streamContents: [:stream|
		object printXMLOn: stream].
	self assert: xmlString = '<simpleobject><abstract>Some words as abstract</abstract></simpleobject>'! !

!MXXmlObjectTest methodsFor: 'testing' stamp: 'NorbertHartl 3/16/2010 14:12'!
testNodeContentWrite
	| object xmlString |
	object := MXSimpleObject new
		abstract: 'Some words as abstract'.
	xmlString := String streamContents: [:stream|
		object printXMLOn: stream].
	self assert: xmlString = '<simpleobject><abstract>Some words as abstract</abstract></simpleobject>'! !

!MXXmlObjectTest methodsFor: 'testing' stamp: 'NorbertHartl 10/9/2010 22:12'!
testObjectRoundtrip
	| object xmlString created |
	object := self simpleObject.
	xmlString := String streamContents: [:stream|
		object printXMLOn: stream].
	created := MXSimpleObject fromXml: xmlString.
	self halt.
	self assert: (object title = created title).
	self assert: (object index = created index).
	self assert: (object date = created date).
	self assert: (object abstract = created abstract).
	self assert: (object token = created token)! !

TestCase subclass: #MXXmlRelationEmbedTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-XMLBinding-Test'!

!MXXmlRelationEmbedTest methodsFor: 'fixtures' stamp: 'NorbertHartl 3/15/2010 18:59'!
embedObject
	^ MXRelationEmbedSource new
		title: 'A title';
		target: (
			MXRelationEmbedTarget new
				name: 'A name')! !

!MXXmlRelationEmbedTest methodsFor: 'testing' stamp: 'jvds 8/19/2010 16:43'!
testEmbedWrite
	| object xmlString |
	object := self embedObject.
	xmlString := String streamContents: [:stream|
		object printXMLOn: stream].
	self assert: (xmlString indexOfSubCollection: 'embedTargetName="A name"') > 0.
	self assert: (xmlString indexOfSubCollection: 'title="A title"') > 0! !

TestCase subclass: #MXXmlRelationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-XMLBinding-Test'!

!MXXmlRelationTest methodsFor: 'as yet unclassified' stamp: 'NorbertHartl 2/17/2010 09:04'!
findTitle: aString in: aCollection
	^ (aCollection 
		detect: [:each| each title = aString]
		ifNone: [ nil ]) notNil! !

!MXXmlRelationTest methodsFor: 'fixtures' stamp: 'NorbertHartl 2/17/2010 13:37'!
onoToMany
	^ MXOneToManySource new
		label: 'A label';
		targets: (
			OrderedCollection new
				add:(MXRelationTarget new
					title: 'title1');
				add:(MXRelationTarget new
					title: 'title2');
				add:(MXRelationTarget new
					title: 'title3');
				yourself
			);
		inlineTargets: (
			OrderedCollection new
				add:(MXRelationInlineTarget new
					title: 'inline title1');
				add:(MXRelationInlineTarget new
					title: 'inline title2');
				add:(MXRelationInlineTarget new
					title: 'inline title3');
				yourself
			)! !

!MXXmlRelationTest methodsFor: 'fixtures' stamp: 'NorbertHartl 2/17/2010 13:37'!
onoToOne
	^ MXOneToOneSource new
		label: 'A label';
		target: (
			MXRelationTarget new
				title: 'A title');
		inlineTarget: (
			MXRelationInlineTarget new
				title: 'An inline title')! !

!MXXmlRelationTest methodsFor: 'testing' stamp: 'jvds 8/30/2010 22:18'!
testOneToManyElementWrite
	| object xmlString |
	object := MXOneToManySource new
		label: 'A label';
		targets: (
			OrderedCollection new
				add:(MXRelationTarget new
					title: 'title1');
				add:(MXRelationTarget new
					title: 'title2');
				yourself).
	xmlString := String streamContents: [:stream|
		object printXMLOn: stream].
	self assert: xmlString = '<toManySource label="A label"><elementTargets><elementtarget title="title1"/> <elementtarget title="title2"/> </elementTargets></toManySource>'! !

!MXXmlRelationTest methodsFor: 'testing' stamp: 'NorbertHartl 3/16/2010 14:32'!
testOneToManyInlineWrite
	| object xmlString |
	object := MXOneToManySource new
		label: 'A label';
		inlineTargets: (
			OrderedCollection new
				add:(MXRelationInlineTarget new
					title: 'title1');
				add:(MXRelationInlineTarget new
					title: 'title2');
				yourself).
	xmlString := String streamContents: [:stream|
		object printXMLOn: stream].
	self assert: xmlString = '<toManySource label="A label"><inlineTarget title="title1"/> <inlineTarget title="title2"/> </toManySource>'! !

!MXXmlRelationTest methodsFor: 'testing' stamp: 'NorbertHartl 3/10/2010 16:15'!
testOneToManyRoundtrip
	| object xmlString created |
	object := self onoToMany.
	xmlString := String streamContents: [:stream|
		object printXMLOn: stream].
	created := MXOneToManySource fromXml: xmlString.
	self assert: object label = created label.
	self assert: created targets notNil.
	self assert: created targets notEmpty.
	self assert: object targets size = created targets size.
	self assert: (self findTitle: 'title1' in: created targets).
	self assert: (self findTitle: 'title2' in: created targets).
	self assert: (self findTitle: 'title3' in: created targets).
	self assert: created inlineTargets notEmpty.
	self assert: (self findTitle: 'inline title1' in: created inlineTargets).
	self assert: (self findTitle: 'inline title2' in: created inlineTargets).
	self assert: (self findTitle: 'inline title3' in: created inlineTargets).
! !

!MXXmlRelationTest methodsFor: 'testing' stamp: 'NorbertHartl 3/16/2010 14:25'!
testOneToOneElementWrite
	| object xmlString |
	object := MXOneToOneSource new
		label: 'A label';
		target: (
			MXRelationTarget new
				title: 'A title').
	xmlString := String streamContents: [:stream|
		object printXMLOn: stream].
	self assert: xmlString = '<toOneSource label="A label"><toOne><elementtarget title="A title"/> </toOne></toOneSource>'! !

!MXXmlRelationTest methodsFor: 'testing' stamp: 'NorbertHartl 3/16/2010 14:26'!
testOneToOneInlineWrite
	| object xmlString |
	object := MXOneToOneSource new
		label: 'A label';
		inlineTarget: (
			MXRelationInlineTarget new
				title: 'A title').
	xmlString := String streamContents: [:stream|
		object printXMLOn: stream].
	self assert: xmlString = '<toOneSource label="A label"><inlineTarget title="A title"/> </toOneSource>'! !

!MXXmlRelationTest methodsFor: 'testing' stamp: 'jvds 8/30/2010 22:20'!
testOneToOneRoundtrip
	| object xmlString created |
	object := self onoToOne.
	xmlString := String streamContents: [:stream|
		object printXMLOn: stream].
	created := MXOneToOneSource fromXml: xmlString.
	self assert: object label = created label.
	self assert: created target notNil.
	self assert: object target title = created target title.
	self assert: object inlineTarget title = created inlineTarget title.
! !

TestCase subclass: #MXXmlStandaloneObjectTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-XMLBinding-Test'!

!MXXmlStandaloneObjectTest methodsFor: 'testing' stamp: 'jvds 8/31/2010 15:07'!
testRead

	| description object |
	
	description := MXStandaloneObject description.
	object := description fromXml: '<MXStandaloneObject><text>long story .....</text></MXStandaloneObject>'.

	self assert: object class = MXStandaloneObject.
	self assert: object text = 'long story .....'

	! !

!MXXmlStandaloneObjectTest methodsFor: 'testing' stamp: 'jvds 8/31/2010 15:07'!
testWrite

	| object node |
	
	object := MXStandaloneObject new
		text: 'long story .....'.
		
	node := object description toXmlNode: object.
	
	"expected: <MXStandaloneObject><text>long story .....</text></MXStandaloneObject>"
	self assert: node name = 'MXStandaloneObject'.
	self assert: (node contentStringAt: 'text') = object text

	! !

TestCase subclass: #MXXmlTypesTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-XMLBinding-Test'!

!MXXmlTypesTest methodsFor: 'testing' stamp: 'jvds 8/5/2010 00:12'!
testBooleanRead
	| created xmlString |
	xmlString := '<typesobject boolean="true"/> '.
	created := MXTypesObject fromXml: xmlString.
	
	self assert: created boolean = true! !

!MXXmlTypesTest methodsFor: 'testing' stamp: 'jvds 8/5/2010 00:04'!
testBooleanWrite
	| object xmlString |
	object := MXTypesObject new
		boolean: true.
	xmlString := String streamContents: [:stream|
		object printXMLOn: stream].
	self assert: xmlString = '<typesobject boolean="true"/> '! !

!MXXmlTypesTest methodsFor: 'testing' stamp: 'jvds 8/5/2010 13:27'!
testDateWrite
	| object xmlString |
	object := MXTypesObject new
		date: (DateAndTime year: 2010 month: 3 day: 10 hour: 4 minute: 4 second: 4 offset: Duration zero).
	xmlString := String streamContents: [:stream|
		object printXMLOn: stream].
	self assert: xmlString = '<typesobject date="2010-03-10T04:04:04+00:00"/> '! !

!MXXmlTypesTest methodsFor: 'testing' stamp: 'jvds 8/9/2010 15:56'!
testFileBinaryRead
	| created xmlString |
	xmlString := '<fileobject abstract="bla"><file filename="bytes.bin" mimetype="application/octet-stream">yJZk</file></fileobject>'.
	created := MXFileObject fromXml: xmlString.
	
	self assert: created abstract = 'bla'.
	self assert: created file filename = 'bytes.bin'.
	self assert: created file isText not.
	self assert: created file contents = (ByteArray with: 200 with: 150 with: 100)! !

!MXXmlTypesTest methodsFor: 'testing' stamp: 'jvds 8/9/2010 15:48'!
testFileBinaryWrite
	| object xmlString |
	object := MXFileObject new
		abstract: 'bla'.
		
	object file
		filename: 'bytes.bin';
		mimetype: 'application/octet-stream';
		contents: (ByteArray with: 200 with: 150 with: 100).
		
	xmlString := String streamContents: [:stream|
		object printXMLOn: stream].
	
	self assert: xmlString = '<fileobject abstract="bla"><file filename="bytes.bin" mimetype="application/octet-stream">yJZk</file></fileobject>'! !

!MXXmlTypesTest methodsFor: 'testing' stamp: 'jvds 8/9/2010 15:54'!
testFileRead
	| created xmlString |
	xmlString := '<fileobject abstract="bla"><file filename="readme.txt" mimetype="text/plain">Hello World!!</file></fileobject>'.
	created := MXFileObject fromXml: xmlString.
	
	self assert: created abstract = 'bla'.
	self assert: created file filename = 'readme.txt'.
	self assert: created file mimetype = 'text/plain'.
	self assert: created file contents asString = 'Hello World!!'! !

!MXXmlTypesTest methodsFor: 'testing' stamp: 'jvds 8/9/2010 15:49'!
testFileWrite
	| object xmlString |
	object := MXFileObject new
		abstract: 'bla'.
		
	object file
		filename: 'readme.txt';
		mimetype: 'text/plain';
		contents: 'Hello World!!'.
		
	xmlString := String streamContents: [:stream|
		object printXMLOn: stream].
	
	self assert: xmlString = '<fileobject abstract="bla"><file filename="readme.txt" mimetype="text/plain">Hello World!!</file></fileobject>'! !

!MXXmlTypesTest methodsFor: 'testing' stamp: 'jvds 8/31/2010 21:48'!
testMultipleOptionsRead

	| created xmlString |

	xmlString := '<typesobject><colors>yellow, green</colors></typesobject>'.
	created := MXTypesObject fromXml: xmlString.

	self assert: created colors = #( yellow green )! !

!MXXmlTypesTest methodsFor: 'testing' stamp: 'jvds 8/31/2010 21:46'!
testMultipleOptionsWrite

	| object xmlString |
	object := MXTypesObject new
		colors: #( yellow green ).
		
	xmlString := String streamContents: [ :stream |
		object printXMLOn: stream].
	self assert: xmlString = '<typesobject><colors>yellow, green</colors></typesobject>'! !

!MXXmlTypesTest methodsFor: 'testing' stamp: 'NorbertHartl 3/16/2010 15:24'!
testNumberWrite
	| object xmlString |
	object := MXTypesObject new
		number: 12345.
	xmlString := String streamContents: [:stream|
		object printXMLOn: stream].
	self assert: xmlString = '<typesobject number="12345"/> '! !

!MXXmlTypesTest methodsFor: 'testing' stamp: 'jvds 8/8/2010 15:48'!
testSingleOptionRead

	| created xmlString |

	xmlString := '<typesobject magnitudeClass="Integer"/> '.
	created := MXTypesObject fromXml: xmlString.
	
	self assert: created magnitudeClass = Integer! !

!MXXmlTypesTest methodsFor: 'testing' stamp: 'jvds 8/8/2010 15:37'!
testSingleOptionWrite

	| object xmlString |
	object := MXTypesObject new
		magnitudeClass: Integer.
		
	xmlString := String streamContents: [:stream|
		object printXMLOn: stream].
	self assert: xmlString = '<typesobject magnitudeClass="Integer"/> '! !

!MXXmlTypesTest methodsFor: 'testing' stamp: 'NorbertHartl 3/16/2010 15:23'!
testStringWrite
	| object xmlString |
	object := MXTypesObject new
		string: 'a string'.
	xmlString := String streamContents: [:stream|
		object printXMLOn: stream].
	self assert: xmlString = '<typesobject string="a string"/> '! !

Object subclass: #MXNodeAccess
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-XMLBinding'!

MXNodeAccess subclass: #MXAttributeAccess
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-XMLBinding'!

!MXAttributeAccess methodsFor: 'as yet unclassified' stamp: 'jvds 8/19/2010 14:06'!
readNode: aNode description: aDescription
	^ aNode attributes 
			at: aDescription xmlAttributeName
			ifAbsent: [nil]
			! !

!MXAttributeAccess methodsFor: 'as yet unclassified' stamp: 'jvds 8/19/2010 14:00'!
write: anObject node: aNode description: aDescription
	aNode 
		attributeAt: aDescription xmlAttributeName 
		put: (anObject perform: aDescription xmlAttributeSelector)! !

MXNodeAccess subclass: #MXContentAccess
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-XMLBinding'!

!MXContentAccess methodsFor: 'as yet unclassified' stamp: 'NorbertHartl 03/11/2010 15:38'!
readNode: aNode description: aDescription
	^ aNode contentString! !

!MXContentAccess methodsFor: 'as yet unclassified' stamp: 'jvds 8/4/2010 22:19'!
write: anObject node: aNode description: aDescription
	aNode
		addContent: anObject asString! !

MXContentAccess subclass: #MXContentCDataAccess
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-XMLBinding'!

!MXContentCDataAccess methodsFor: 'as yet unclassified' stamp: 'jvds 8/14/2010 16:26'!
write: anObject node: aNode description: aDescription
	aNode addNode: (XMLCData string: anObject asString)! !

MXNodeAccess subclass: #MXElementAccess
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-XMLBinding'!

!MXElementAccess methodsFor: 'as yet unclassified' stamp: 'jvds 8/5/2010 13:15'!
readNode: aNode description: aDescription
	^ aNode elementAt: aDescription xmlElementName! !

!MXElementAccess methodsFor: 'as yet unclassified' stamp: 'jvds 8/31/2010 12:05'!
write: anObject node: aNode description: aDescription
	| childNode |
	childNode := aDescription xmlWriterInstance 
		write: anObject node: aNode description: aDescription;
		writeNode.	
	self writeNode: childNode node: aNode description: aDescription! !

!MXElementAccess methodsFor: 'as yet unclassified' stamp: 'jvds 8/4/2010 22:17'!
writeNode: aChildNode node: aNode description: aDescription
	aNode ~~ aChildNode ifTrue: [
		(aChildNode elements notEmpty 
			or: [aChildNode contents notEmpty 
				or: [aChildNode attributes notEmpty]]) ifTrue: [
					aNode addElement: aChildNode]]! !

!MXNodeAccess methodsFor: 'as yet unclassified' stamp: 'jvds 8/7/2010 15:46'!
write: aString node: aNode description: aDescription
	self subclassResponsibility! !

Object subclass: #MXObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-XMLBinding'!

MXObject subclass: #MXFileObject
	instanceVariableNames: 'file abstract'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-XMLBinding-Test'!

!MXFileObject class methodsFor: 'as yet unclassified' stamp: 'jvds 8/9/2010 15:12'!
descriptionAbstract

	^ MAStringDescription new
		accessor: #abstract;
		label: 'Abstract';
		beXmlExportable;	
		yourself! !

!MXFileObject class methodsFor: 'as yet unclassified' stamp: 'jvds 8/9/2010 15:47'!
descriptionFile

	^ MAFileDescription new
		accessor: #file;
		label: 'File';
		xmlNode: MXChildNode;
		beXmlExportable;	
		yourself! !

!MXFileObject class methodsFor: 'as yet unclassified' stamp: 'jvds 8/9/2010 15:09'!
descriptionFilePharo: aDescription

	^ aDescription
		kind: MAExternalFileModel;
		yourself! !

!MXFileObject class methodsFor: 'accessing' stamp: 'jvds 8/9/2010 15:14'!
fileModel
	^ (self description detect: [ :each |
		each = self descriptionFile ])
			kind! !

!MXFileObject class methodsFor: 'testing' stamp: 'jvds 8/9/2010 15:52'!
isAbstract
	^false! !

!MXFileObject class methodsFor: 'accessing' stamp: 'jvds 8/9/2010 15:38'!
xmlElementName
	^ 'fileobject'! !

!MXFileObject methodsFor: 'accessing' stamp: 'jvds 8/9/2010 15:11'!
abstract
	^ abstract! !

!MXFileObject methodsFor: 'accessing' stamp: 'jvds 8/9/2010 15:11'!
abstract: anObject
	abstract := anObject! !

!MXFileObject methodsFor: 'accessing' stamp: 'jvds 8/9/2010 15:14'!
file
	^ file ifNil: [ file := self class fileModel new ]! !

!MXFileObject methodsFor: 'accessing' stamp: 'jvds 8/9/2010 15:11'!
file: anObject
	file := anObject! !

!MXObject class methodsFor: 'accessing-description' stamp: 'NorbertHartl 02/18/2010 14:41'!
descriptionContainer
	^super descriptionContainer
		xmlElementName: self xmlElementName;
		yourself
! !

!MXObject class methodsFor: 'accessing' stamp: 'NorbertHartl 02/18/2010 09:49'!
forElementNamed: aString
	self withAllConcreteClassesDo: [ :each |
		(each description xmlElementName = aString)
			ifTrue: [ ^each new ] ].
	self error: 'unknown element name: ', aString! !

!MXObject class methodsFor: 'instance creation' stamp: 'NorbertHartl 2/15/2010 11:27'!
fromXml: aString
	^self description fromXml: aString! !

!MXObject class methodsFor: 'instance creation' stamp: 'NorbertHartl 10/10/2010 00:22'!
fromXmlNode: aString
	^self description fromXmlNode: aString! !

!MXObject class methodsFor: 'testing' stamp: 'NorbertHartl 2/15/2010 11:27'!
isAbstract
	^ true! !

!MXObject class methodsFor: 'reflection' stamp: 'NorbertHartl 2/15/2010 11:27'!
withAllConcreteClasses
	^Array streamContents: [ :stream |
		self withAllConcreteClassesDo: [ :each |
			stream nextPut: each ] ]! !

!MXObject class methodsFor: 'reflection' stamp: 'NorbertHartl 2/15/2010 11:27'!
withAllConcreteClassesDo: aBlock
	self withAllSubclassesDo: [ :each |
		each isAbstract ifFalse: [
			aBlock value: each ] ]! !

!MXObject class methodsFor: 'accessing' stamp: 'NorbertHartl 02/18/2010 14:42'!
xmlElementName
	self subclassResponsibility! !

!MXObject methodsFor: 'printing' stamp: 'jvds 8/31/2010 13:17'!
printXMLOn: aStream
	self toXml printXMLOn: (XMLWriter on: aStream)! !

!MXObject methodsFor: 'converting' stamp: 'jvds 8/31/2010 13:16'!
toXml
	^ self toXml: nil! !

!MXObject methodsFor: 'converting' stamp: 'jvds 8/31/2010 12:23'!
toXml: aParentNode
	^ self toXml: aParentNode using: self description! !

!MXObject methodsFor: 'converting' stamp: 'jvds 8/31/2010 12:23'!
toXml: aParentNode using: aDescription
	^aDescription toXmlNode: self parent: aParentNode! !

MXObject subclass: #MXOneToManySource
	instanceVariableNames: 'label targets inlineTargets'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-XMLBinding-Test'!

!MXOneToManySource class methodsFor: 'description' stamp: 'NorbertHartl 2/21/2010 13:56'!
descriptionInlineTargets
	^(MAToManyRelationDescription new 
		accessor: #inlineTargets; 
		label: '1:m inline targets'; 
		priority: 600)
		reference: MXRelationInlineTarget description;
		xmlNode: MXSameNode;
		xmlAccess: MXElementAccess;
		xmlElementName: 'itargets';
		beXmlExportable;
		yourself! !

!MXOneToManySource class methodsFor: 'description' stamp: 'NorbertHartl 2/21/2010 11:10'!
descriptionLabel
	^ MAStringDescription new
		accessor: #label;
		priority: 100;
		label: 'Label';
		xmlNode: MXSameNode;
		xmlAccess: MXAttributeAccess;
		beXmlExportable;
		yourself! !

!MXOneToManySource class methodsFor: 'description' stamp: 'NorbertHartl 3/16/2010 14:29'!
descriptionTargets
	^(MAToManyRelationDescription new 
		accessor: #targets; 
		label: '1:m targets'; 
		priority: 600)
		reference: MXRelationTarget description;
		xmlNode: MXChildNode;
		xmlAccess: MXElementAccess;
		xmlElementName: 'elementTargets';
		beXmlExportable;
		yourself! !

!MXOneToManySource class methodsFor: 'testing' stamp: 'NorbertHartl 2/17/2010 06:54'!
isAbstract
	^ false! !

!MXOneToManySource class methodsFor: 'as yet unclassified' stamp: 'NorbertHartl 02/18/2010 14:42'!
xmlElementName
	^ 'toManySource'! !

!MXOneToManySource methodsFor: 'as yet unclassified' stamp: 'NorbertHartl 2/17/2010 08:59'!
inlineTargets
	^ inlineTargets! !

!MXOneToManySource methodsFor: 'as yet unclassified' stamp: 'NorbertHartl 2/17/2010 08:59'!
inlineTargets: aCollection
	inlineTargets := aCollection! !

!MXOneToManySource methodsFor: 'accessing' stamp: 'NorbertHartl 2/17/2010 06:54'!
label
	^ label! !

!MXOneToManySource methodsFor: 'accessing' stamp: 'NorbertHartl 2/17/2010 06:54'!
label: aString
	label := aString! !

!MXOneToManySource methodsFor: 'accessing' stamp: 'NorbertHartl 2/17/2010 06:54'!
targets
	^ targets! !

!MXOneToManySource methodsFor: 'accessing' stamp: 'NorbertHartl 2/17/2010 06:54'!
targets: aCollection
	targets := aCollection! !

MXObject subclass: #MXOneToOneSource
	instanceVariableNames: 'label target inlineTarget'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-XMLBinding-Test'!

!MXOneToOneSource class methodsFor: 'description' stamp: 'NorbertHartl 2/21/2010 11:49'!
descriptionInlineTarget
	^(MAToOneRelationDescription new 
		accessor: #inlineTarget; 
		label: '1:1 inline target'; 
		priority: 600)
		xmlElementName: 'inlineToOne';
		xmlNode: MXSameNode;
		xmlAccess: MXElementAccess;
		reference: MXRelationInlineTarget description;
		beXmlExportable;
		yourself! !

!MXOneToOneSource class methodsFor: 'description' stamp: 'NorbertHartl 2/21/2010 11:12'!
descriptionLabel
	^ MAStringDescription new
		accessor: #label;
		priority: 100;
		label: 'Label';
		xmlNode: MXSameNode;
		xmlAccess: MXAttributeAccess;
		beXmlExportable;
		yourself! !

!MXOneToOneSource class methodsFor: 'description' stamp: 'NorbertHartl 2/21/2010 11:49'!
descriptionTarget
	^(MAToOneRelationDescription new 
		accessor: #target; 
		label: '1:1 target'; 
		priority: 600)
		xmlElementName: 'toOne';
		xmlNode: MXChildNode;
		xmlAccess: MXElementAccess;
		reference: MXRelationTarget description;
		beXmlExportable;
		yourself! !

!MXOneToOneSource class methodsFor: 'testing' stamp: 'NorbertHartl 2/17/2010 06:51'!
isAbstract
	^ false! !

!MXOneToOneSource class methodsFor: 'as yet unclassified' stamp: 'NorbertHartl 02/18/2010 14:43'!
xmlElementName
	^ 'toOneSource'! !

!MXOneToOneSource methodsFor: 'as yet unclassified' stamp: 'NorbertHartl 2/17/2010 08:35'!
inlineTarget
	^ inlineTarget! !

!MXOneToOneSource methodsFor: 'as yet unclassified' stamp: 'NorbertHartl 2/17/2010 08:36'!
inlineTarget: anObject
	inlineTarget := anObject! !

!MXOneToOneSource methodsFor: 'accessing' stamp: 'NorbertHartl 2/17/2010 06:43'!
label
	^ label! !

!MXOneToOneSource methodsFor: 'accessing' stamp: 'NorbertHartl 2/17/2010 06:42'!
label: aString
	label := aString! !

!MXOneToOneSource methodsFor: 'accessing' stamp: 'NorbertHartl 2/17/2010 06:45'!
target
	^ target! !

!MXOneToOneSource methodsFor: 'accessing' stamp: 'NorbertHartl 2/17/2010 06:44'!
target: anObject
	target := anObject! !

MXObject subclass: #MXRelationEmbedSource
	instanceVariableNames: 'title target'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-XMLBinding-Test'!

!MXRelationEmbedSource class methodsFor: 'as yet unclassified' stamp: 'NorbertHartl 3/16/2010 14:01'!
descriptionTarget
	^(MAToOneRelationDescription new 
		accessor: #target; 
		label: '1:1 embed target'; 
		priority: 600)
		xmlElementName: 'embedTarget';
		xmlNode: MXSameNode;
		xmlAccess: MXAttributeAccess;
		xmlAttributeName: 'embedTargetName';
		xmlAttributeSelector: #name;
		reference: MXRelationEmbedTarget description;
		beXmlExportable;
		yourself! !

!MXRelationEmbedSource class methodsFor: 'description' stamp: 'jvds 8/31/2010 18:18'!
descriptionTitle
	^ MAStringDescription new
		accessor: #title;
		priority: 100;
		label: 'Title';
		beXmlAttribute;
		yourself! !

!MXRelationEmbedSource class methodsFor: 'testing' stamp: 'NorbertHartl 3/15/2010 18:53'!
isAbstract
	^ false! !

!MXRelationEmbedSource class methodsFor: 'as yet unclassified' stamp: 'NorbertHartl 3/15/2010 18:56'!
xmlElementName
	^ 'relationEmbedSource'! !

!MXRelationEmbedSource methodsFor: 'as yet unclassified' stamp: 'NorbertHartl 3/15/2010 19:01'!
target
	^ target! !

!MXRelationEmbedSource methodsFor: 'as yet unclassified' stamp: 'NorbertHartl 3/15/2010 19:01'!
target: anObject
	target := anObject! !

!MXRelationEmbedSource methodsFor: 'accessing' stamp: 'NorbertHartl 3/15/2010 18:53'!
title
	^ title! !

!MXRelationEmbedSource methodsFor: 'accessing' stamp: 'NorbertHartl 3/15/2010 18:53'!
title: aString
	title := aString! !

MXObject subclass: #MXRelationEmbedTarget
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-XMLBinding-Test'!

!MXRelationEmbedTarget class methodsFor: 'description' stamp: 'NorbertHartl 3/15/2010 18:55'!
descriptionName
	^ MAStringDescription new
		accessor: #name;
		priority: 100;
		label: 'Name';
		xmlNode: MXSameNode;
		xmlAccess: MXAttributeAccess;
		beXmlExportable;
		yourself! !

!MXRelationEmbedTarget class methodsFor: 'testing' stamp: 'NorbertHartl 3/15/2010 18:54'!
isAbstract
	^ false! !

!MXRelationEmbedTarget class methodsFor: 'as yet unclassified' stamp: 'NorbertHartl 3/15/2010 18:56'!
xmlElementName
	^ 'relationEmbedTarget'! !

!MXRelationEmbedTarget methodsFor: 'accessing' stamp: 'NorbertHartl 3/15/2010 18:54'!
name
	^ name! !

!MXRelationEmbedTarget methodsFor: 'accessing' stamp: 'NorbertHartl 3/15/2010 18:54'!
name: aString
	name := aString! !

MXObject subclass: #MXRelationInlineTarget
	instanceVariableNames: 'title'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-XMLBinding-Test'!

!MXRelationInlineTarget class methodsFor: 'description' stamp: 'NorbertHartl 2/21/2010 11:13'!
descriptionTitle
	^ MAStringDescription new
		accessor: #title;
		priority: 100;
		label: 'Title';
		xmlNode: MXSameNode;
		xmlAccess: MXAttributeAccess;
		beXmlExportable;
		yourself! !

!MXRelationInlineTarget class methodsFor: 'testing' stamp: 'NorbertHartl 2/17/2010 13:36'!
isAbstract
	^ false! !

!MXRelationInlineTarget class methodsFor: 'as yet unclassified' stamp: 'NorbertHartl 02/18/2010 14:43'!
xmlElementName
	^ 'inlineTarget'! !

!MXRelationInlineTarget methodsFor: 'accessing' stamp: 'NorbertHartl 2/17/2010 13:36'!
title
	^ title! !

!MXRelationInlineTarget methodsFor: 'accessing' stamp: 'NorbertHartl 2/17/2010 13:36'!
title: aString
	title := aString! !

MXObject subclass: #MXRelationTarget
	instanceVariableNames: 'title'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-XMLBinding-Test'!

!MXRelationTarget class methodsFor: 'description' stamp: 'NorbertHartl 2/21/2010 11:14'!
descriptionTitle
	^ MAStringDescription new
		accessor: #title;
		priority: 100;
		label: 'Title';
		xmlNode: MXSameNode;
		xmlAccess: MXAttributeAccess;
		beXmlExportable;
		yourself! !

!MXRelationTarget class methodsFor: 'testing' stamp: 'NorbertHartl 2/17/2010 06:51'!
isAbstract
	^ false! !

!MXRelationTarget class methodsFor: 'as yet unclassified' stamp: 'NorbertHartl 02/18/2010 14:54'!
xmlElementName
	^ 'elementtarget'! !

!MXRelationTarget methodsFor: 'accessing' stamp: 'NorbertHartl 2/17/2010 06:42'!
title
	^ title! !

!MXRelationTarget methodsFor: 'accessing' stamp: 'NorbertHartl 2/17/2010 06:42'!
title: aString
	title := aString! !

MXObject subclass: #MXSimpleObject
	instanceVariableNames: 'title abstract token index date'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-XMLBinding-Test'!

!MXSimpleObject class methodsFor: 'description' stamp: 'NorbertHartl 2/21/2010 11:46'!
descriptionAbstract
	^ MAStringDescription new
		accessor: #abstract;
		priority: 150;
		label: 'Abstract';
		xmlNode: MXChildNode;
		xmlAccess: MXContentAccess;
		beXmlExportable;
		yourself! !

!MXSimpleObject class methodsFor: 'description' stamp: 'NorbertHartl 2/21/2010 10:55'!
descriptionIndex
	^ MANumberDescription new
		accessor: #index;
		priority: 200;
		label: 'Index';
		xmlNode: MXSameNode;
		xmlAccess: MXAttributeAccess;
		beXmlExportable;	
		yourself! !

!MXSimpleObject class methodsFor: 'description' stamp: 'NorbertHartl 2/21/2010 09:30'!
descriptionTitle
	^ MAStringDescription new
		accessor: #title;
		priority: 100;
		label: 'Title';
		beXmlExportable;
		xmlNode: MXSameNode;
		xmlAccess: MXAttributeAccess;
		yourself! !

!MXSimpleObject class methodsFor: 'description' stamp: 'NorbertHartl 2/21/2010 08:36'!
descriptionToken
	^ MAStringDescription new
		accessor: #token;
		priority: 180;
		label: 'Title';
		xmlNode: MXChildNode;
		xmlAccess: MXAttributeAccess;
		xmlAttributeName: 'type';
		beXmlExportable;
		yourself! !

!MXSimpleObject class methodsFor: 'testing' stamp: 'NorbertHartl 2/17/2010 05:20'!
isAbstract
	^ false! !

!MXSimpleObject class methodsFor: 'as yet unclassified' stamp: 'NorbertHartl 02/18/2010 14:44'!
xmlElementName
	^ 'simpleobject'! !

!MXSimpleObject methodsFor: 'accessing' stamp: 'NorbertHartl 2/17/2010 05:26'!
abstract
	^ abstract! !

!MXSimpleObject methodsFor: 'accessing' stamp: 'NorbertHartl 2/17/2010 05:26'!
abstract: aString
	abstract := aString! !

!MXSimpleObject methodsFor: 'accessing' stamp: 'NorbertHartl 2/17/2010 05:12'!
date
	^ date! !

!MXSimpleObject methodsFor: 'accessing' stamp: 'NorbertHartl 2/17/2010 05:12'!
date: aDate
	date := aDate! !

!MXSimpleObject methodsFor: 'accessing' stamp: 'NorbertHartl 2/17/2010 05:12'!
index
	^ index! !

!MXSimpleObject methodsFor: 'accessing' stamp: 'NorbertHartl 2/17/2010 05:12'!
index: aNumber
	index := aNumber! !

!MXSimpleObject methodsFor: 'accessing' stamp: 'NorbertHartl 2/17/2010 05:12'!
title
	^ title! !

!MXSimpleObject methodsFor: 'accessing' stamp: 'NorbertHartl 2/17/2010 05:11'!
title: aString
	title := aString! !

!MXSimpleObject methodsFor: 'accessing' stamp: 'NorbertHartl 2/17/2010 05:36'!
token
	^ token! !

!MXSimpleObject methodsFor: 'accessing' stamp: 'NorbertHartl 2/17/2010 05:37'!
token: aString
	token := aString! !

MXObject subclass: #MXTypesObject
	instanceVariableNames: 'string number date boolean magnitudeClass colors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-XMLBinding-Test'!

!MXTypesObject class methodsFor: 'description' stamp: 'jvds 8/5/2010 00:03'!
descriptionBoolean
	^ MABooleanDescription new
		accessor: #boolean;
		priority: 120;
		label: 'Boolean';
		beXmlExportable;
		yourself! !

!MXTypesObject class methodsFor: 'description' stamp: 'jvds 8/31/2010 18:38'!
descriptionColors

	^ MAMultipleOptionDescription new
		accessor: #colors;
		options: #( red yellow blue green);
		accessor: #colors;
		beXmlChildContent;
		yourself
! !

!MXTypesObject class methodsFor: 'description' stamp: 'NorbertHartl 3/16/2010 15:14'!
descriptionDate
	^ MADateDescription new
		accessor: #date;
		priority: 110;
		label: 'Date';
		beXmlExportable;
		yourself! !

!MXTypesObject class methodsFor: 'description' stamp: 'jvds 8/8/2010 15:29'!
descriptionMagnitudeClass

	^ MASingleOptionDescription new
		options: Magnitude allSubclasses;
		reference: MAClassDescription new;
		accessor: #magnitudeClass;
		beXmlExportable;
		yourself
! !

!MXTypesObject class methodsFor: 'description' stamp: 'NorbertHartl 3/16/2010 15:15'!
descriptionNumber
	^ MANumberDescription new
		accessor: #number;
		priority: 105;
		label: 'Number';
		beXmlExportable;	
		yourself! !

!MXTypesObject class methodsFor: 'description' stamp: 'NorbertHartl 3/16/2010 15:15'!
descriptionString
	^ MAStringDescription new
		accessor: #string;
		priority: 100;
		label: 'String';
		beXmlExportable;
		yourself! !

!MXTypesObject class methodsFor: 'testing' stamp: 'NorbertHartl 3/16/2010 15:14'!
isAbstract
	^ false! !

!MXTypesObject class methodsFor: 'as yet unclassified' stamp: 'NorbertHartl 3/16/2010 15:23'!
xmlElementName
	^ 'typesobject'! !

!MXTypesObject methodsFor: 'accessing' stamp: 'jvds 8/5/2010 00:03'!
boolean
	^ boolean! !

!MXTypesObject methodsFor: 'accessing' stamp: 'jvds 8/5/2010 00:03'!
boolean: anObject
	boolean := anObject! !

!MXTypesObject methodsFor: 'accessing' stamp: 'jvds 8/31/2010 18:34'!
colors
	^ colors! !

!MXTypesObject methodsFor: 'accessing' stamp: 'jvds 8/31/2010 18:34'!
colors: anObject
	colors := anObject! !

!MXTypesObject methodsFor: 'accessing' stamp: 'NorbertHartl 3/16/2010 15:14'!
date
	^ date! !

!MXTypesObject methodsFor: 'accessing' stamp: 'NorbertHartl 3/16/2010 15:14'!
date: aDate
	date := aDate! !

!MXTypesObject methodsFor: 'accessing' stamp: 'jvds 8/8/2010 15:28'!
magnitudeClass
	^ magnitudeClass! !

!MXTypesObject methodsFor: 'accessing' stamp: 'jvds 8/8/2010 15:28'!
magnitudeClass: anObject
	magnitudeClass := anObject! !

!MXTypesObject methodsFor: 'accessing' stamp: 'NorbertHartl 3/16/2010 15:17'!
number
	^ number! !

!MXTypesObject methodsFor: 'accessing' stamp: 'NorbertHartl 3/16/2010 15:17'!
number: aNumber
	number := aNumber! !

!MXTypesObject methodsFor: 'accessing' stamp: 'NorbertHartl 3/16/2010 15:16'!
string
	^ string! !

!MXTypesObject methodsFor: 'accessing' stamp: 'NorbertHartl 3/16/2010 15:16'!
string: aString
	string := aString! !

Object subclass: #MXStandaloneObject
	instanceVariableNames: 'text'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-XMLBinding-Test'!

!MXStandaloneObject class methodsFor: 'as yet unclassified' stamp: 'jvds 8/31/2010 15:06'!
descriptionContainer

	^super descriptionContainer
		kind: self;
		xmlElementName: self name! !

!MXStandaloneObject class methodsFor: 'as yet unclassified' stamp: 'jvds 8/31/2010 14:18'!
descriptionText
	^ MAStringDescription new
		accessor: #text;
		label: 'Text';
		beXmlChildContent;
		yourself! !

!MXStandaloneObject class methodsFor: 'testing' stamp: 'jvds 8/31/2010 15:05'!
isAbstract
	^false! !

!MXStandaloneObject methodsFor: 'accessing' stamp: 'jvds 8/31/2010 14:17'!
text
	^ text! !

!MXStandaloneObject methodsFor: 'accessing' stamp: 'jvds 8/31/2010 14:17'!
text: anObject
	text := anObject! !

Object subclass: #MXTargetNode
	instanceVariableNames: 'currentNode writeNode description'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-XMLBinding'!

MXTargetNode subclass: #MXChildNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-XMLBinding'!

!MXChildNode methodsFor: 'as yet unclassified' stamp: 'jvds 8/5/2010 13:46'!
readNode
	^ currentNode elementAt: description xmlElementName! !

!MXChildNode methodsFor: 'as yet unclassified' stamp: 'NorbertHartl 3/16/2010 15:04'!
writeNode
	^ writeNode ifNil: [
		writeNode := XMLElement new name: description xmlElementName]! !

MXTargetNode subclass: #MXSameNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-XMLBinding'!

!MXSameNode methodsFor: 'as yet unclassified' stamp: 'NorbertHartl 3/16/2010 15:05'!
readNode
	^ currentNode! !

!MXSameNode methodsFor: 'as yet unclassified' stamp: 'NorbertHartl 3/16/2010 15:02'!
writeNode
	^ currentNode! !

MXTargetNode subclass: #MXSeparateNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-XMLBinding'!

!MXSeparateNode methodsFor: 'as yet unclassified' stamp: 'NorbertHartl 3/16/2010 15:05'!
readNode
	^ currentNode! !

!MXSeparateNode methodsFor: 'as yet unclassified' stamp: 'NorbertHartl 3/16/2010 15:05'!
writeNode
	^ writeNode ifNil: [
		writeNode := XMLElement new name: description xmlElementName]! !

!MXTargetNode methodsFor: 'as yet unclassified' stamp: 'NorbertHartl 2/21/2010 08:55'!
currentNode
	^ currentNode! !

!MXTargetNode methodsFor: 'as yet unclassified' stamp: 'NorbertHartl 2/21/2010 09:05'!
currentNode: aNode
	currentNode := aNode! !

!MXTargetNode methodsFor: 'as yet unclassified' stamp: 'NorbertHartl 2/21/2010 09:10'!
description: aDescription
	description := aDescription! !

!MXTargetNode methodsFor: 'as yet unclassified' stamp: 'NorbertHartl 3/16/2010 15:00'!
readNode
	self subclassResponsibility! !

!MXTargetNode methodsFor: 'as yet unclassified' stamp: 'NorbertHartl 3/16/2010 15:03'!
writeNode
	self subclassResponsibility! !
